module Paths_I1M (
    version,
    getBinDir, getLibDir, getDataDir, getLibexecDir,
    getDataFileName
  ) where

import qualified Control.Exception as Exception
import Data.Version (Version(..))
import System.Environment (getEnv)
import Prelude

catchIO :: IO a -> (Exception.IOException -> IO a) -> IO a
catchIO = Exception.catch


version :: Version
version = Version {versionBranch = [0,1,0,4], versionTags = []}
bindir, libdir, datadir, libexecdir :: FilePath

bindir     = "/home/jalonso/.cabal/bin"
libdir     = "/home/jalonso/.cabal/lib/I1M-0.1.0.4/ghc-7.6.3"
datadir    = "/home/jalonso/.cabal/share/I1M-0.1.0.4"
libexecdir = "/home/jalonso/.cabal/libexec"

getBinDir, getLibDir, getDataDir, getLibexecDir :: IO FilePath
getBinDir = catchIO (getEnv "I1M_bindir") (\_ -> return bindir)
getLibDir = catchIO (getEnv "I1M_libdir") (\_ -> return libdir)
getDataDir = catchIO (getEnv "I1M_datadir") (\_ -> return datadir)
getLibexecDir = catchIO (getEnv "I1M_libexecdir") (\_ -> return libexecdir)

getDataFileName :: FilePath -> IO FilePath
getDataFileName name = do
  dir <- getDataDir
  return (dir ++ "/" ++ name)
